
Structure _ScrollingTextGadget
  Text$
  TextX.f
  TextY.f
  GadgetX.l
  GadgetY.l
  GadgetBreite.l
  GadgetHoehe.l
  idGadget.l
  idImageBuffer.l
  TextLenght.l
  TextHeight.l
  TextColor.l
  Backcolor.l
  Scrollumschaltung.b
  ScrollingSpeed.f
  FontID.l
EndStructure

Procedure ScrollingTextGadget_Create(GadgetID.l, X.l, Y.l, Breite.l, Hoehe.l, Text$, FontID.l, ScrollingSpeed.f = 0.1, TextFarbe.l = $0000ff, Farbe.l = $000000)
  Protected *TextGadget._ScrollingTextGadget = AllocateMemory(SizeOf(_ScrollingTextGadget))
  
  *TextGadget\idImageBuffer = CreateImage(#PB_Any, Breite, Hoehe)
  *TextGadget\GadgetX = X
  *TextGadget\GadgetY = Y
  *TextGadget\GadgetHoehe = Hoehe
  *TextGadget\GadgetBreite = Breite
  *TextGadget\idGadget = GadgetID
  *TextGadget\Text$ = Text$
  *TextGadget\Backcolor = Farbe
  *TextGadget\TextColor = TextFarbe
  *TextGadget\FontID = FontID
  *TextGadget\ScrollingSpeed = ScrollingSpeed
  
  ImageGadget(GadgetID, X, Y, Breite, Hoehe, 0)
  
  ProcedureReturn *TextGadget
EndProcedure

Procedure ScrollingTextGadget_Refresh(*ScrollingTextGadget._ScrollingTextGadget)
  If StartDrawing(ImageOutput(*ScrollingTextGadget\idImageBuffer))
    Box(0, 0, *ScrollingTextGadget\GadgetBreite, *ScrollingTextGadget\GadgetHoehe, *ScrollingTextGadget\Backcolor)
    DrawingFont(*ScrollingTextGadget\FontID)
    *ScrollingTextGadget\TextHeight = TextHeight(*ScrollingTextGadget\Text$)
    *ScrollingTextGadget\TextLenght = TextWidth(*ScrollingTextGadget\Text$)
    *ScrollingTextGadget\TextY = (*ScrollingTextGadget\GadgetHoehe/2)-(*ScrollingTextGadget\TextHeight/2)
    
    If *ScrollingTextGadget\TextLenght > *ScrollingTextGadget\GadgetBreite
      If *ScrollingTextGadget\Scrollumschaltung = 0;*ScrollingTextGadget\TextX + *ScrollingTextGadget\TextLenght > *ScrollingTextGadget\GadgetBreite And *ScrollingTextGadget\Scrollumschaltung = 0
        *ScrollingTextGadget\TextX - *ScrollingTextGadget\ScrollingSpeed
        If *ScrollingTextGadget\TextX + *ScrollingTextGadget\TextLenght < *ScrollingTextGadget\GadgetBreite
          *ScrollingTextGadget\Scrollumschaltung = 1
        EndIf
      Else
        *ScrollingTextGadget\TextX + *ScrollingTextGadget\ScrollingSpeed
        If *ScrollingTextGadget\TextX > 0 
          *ScrollingTextGadget\Scrollumschaltung = 0
        EndIf
      EndIf
    Else
      *ScrollingTextGadget\TextX = *ScrollingTextGadget\GadgetBreite/2 - *ScrollingTextGadget\TextLenght/2
    EndIf
    
    DrawText(*ScrollingTextGadget\TextX, *ScrollingTextGadget\TextY, *ScrollingTextGadget\Text$, *ScrollingTextGadget\TextColor, *ScrollingTextGadget\Backcolor)
    StopDrawing()
  EndIf
  SetGadgetState(*ScrollingTextGadget\idGadget, ImageID(*ScrollingTextGadget\idImageBuffer))
EndProcedure

Procedure ScrollingTextGadget_SetText(*ScrollingTextGadget._ScrollingTextGadget, Text$)
  If *ScrollingTextGadget
    *ScrollingTextGadget\Text$ = Text$
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure ScrollingTextGadget_SetScrollingSpeed(*ScrollingTextGadget._ScrollingTextGadget, Speed.f)
  If *ScrollingTextGadget
    *ScrollingTextGadget\ScrollingSpeed = Speed
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

; IDE Options = PureBasic 4.60 Beta 3 (Windows - x86)
; CursorPosition = 61
; FirstLine = 26
; Folding = -
; EnableXP